#include "arg.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void
next_set(char **av, char ***next_av)
{
	if(next_av == NULL) return;
	if(av == NULL || *av == NULL){
		*next_av = NULL;
	}else{
		av++;
		*next_av = *av ? av : NULL;
	}
}

int
cui_arg_exist(char **av, char *key, char ***next_av)
{
	if(av == NULL) return 0;
	for(; *av; av++) if(strcmp(*av, key) == 0) break;
	next_set(av, next_av);
	return *av != NULL;
}

char *
cui_arg_str(char **av, char *key, char *def, char ***next_av)
{
	char **nx;
	if(!cui_arg_exist(av, key, &nx)) return def;
	if(nx == NULL) return def;
	next_set(nx, next_av);
	return *nx;
}

int
cui_arg_int(char **av, char *key, int def, char ***next_av)
{
	char *s = cui_arg_str(av, key, NULL, next_av);
	return s ? strtol(s, NULL, 0) : def;
}

/* EOF */
