#include "dbg.h"
#include "arg.h"
#include "sock.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>

static int fd = -1;
int cui_dbg_enable = 1;

void
cui_dbg_open(char **av)
{
	char *s;

	if(fd != -1) return;

	if(cui_arg_exist(av, "-dbg-en0", NULL)) cui_dbg_enable = 0;

	if(!cui_arg_exist(av, "-dbg", NULL)) return;
	s = cui_arg_str(av, "-dbg", "localhost:12345", NULL);

	fd = cui_conn(s);
}

void
cui_dbg_close(void)
{
	if(fd != -1){
		close(fd);
		fd = -1;
	}
}

void
cui_dbg(char *fmt, ...)
{
	va_list ap;
	char buf[1024];

	if(fd == -1) return;
	if(!cui_dbg_enable) return;
	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	write(fd, buf, strlen(buf));
	va_end(ap);
}

/* EOF */
