#include "dialog.h"
#include "button.h"
#include "handler.h"
#include "etext.h"
#include "num.h"
#include <string.h>

int
cui_simple_dialog_hdr(cui obj, int evt, int val, void *prm)
{
	cui_simple_dialog p = (cui_simple_dialog)prm;
	p->btn_result = cui_button_str_get(obj);
	cui_quit();
	return TRUE;
}

cui
cui_simple_dialog_new(cui parent, int x, int y, char *s, char *s_btn1, char *s_btn2)
{
	int n, n1, n2, x2, w, w2;
	cui obj = cui_alloc(sizeof(struct cui_simple_dialog));
	cui_simple_dialog p = (cui_simple_dialog)obj;

	n = strlen(s);
	n1 = strlen(s_btn1);
	n2 = strlen(s_btn2);
	w = 3 + n + 3;
	x2 = 4 + 1 + n1 + 1 + 3;
	w2 = x2 + 1 + n2 + 1 + 3;
	w = w2 > w ? w2 : w;
	
	cui_panel_init(obj, parent, x, y, w, 7);
	p->label = cui_label_new(obj, 3, 2, s);
	p->btn1 = cui_button_new(obj, 4, 4, s_btn1);
	p->btn2 = cui_button_new(obj, x2, 4, s_btn2);

	cui_bind(p->btn1, CUI_EVT_BUTTON, cui_simple_dialog_hdr, obj);
	cui_bind(p->btn2, CUI_EVT_BUTTON, cui_simple_dialog_hdr, obj);
	p->btn_result = "not yet";
	return obj;
}

static int
msg_hdr(cui obj, int evt, int val, void *prm)
{
	switch(evt){
	case CUI_EVT_BUTTON:
		cui_quit();
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

void
cui_msg_dialog(cui parent, char *s)
{
	int n = strlen(s);
	int x = (parent->w - (n+4)) / 2;
	int y = (parent->h - 5) / 2;
	cui panel = cui_panel_new(parent, x, y, n+4, 5);
	cui view = cui_base_new(panel, 2, 1, n, 3);
	cui ok;

	cui_label_new(view, 0, 0, s);
	ok = cui_button_new(view, (n-4)/2, 2, "OK");
	cui_bind(ok, CUI_EVT_BUTTON, msg_hdr, NULL);

	cui_main(panel, ok);
	cui_hide(panel);
	cui_draw(parent);
	cui_del_free(panel);
}

static int
ok_cancel_hdr(cui obj, int evt, int val, void *prm)
{
	int *ret = (int *)prm;;
	switch(evt){
	case CUI_EVT_BUTTON:
		*ret = (strcmp(cui_button_str_get(obj), "OK") == 0);
		cui_quit();
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

static cui host_port_panel = NULL;
static cui host_port_etxt = NULL;
static cui host_port_num = NULL;
static int host_port_result;

int
cui_host_port_dialog(cui parent, int x, int y, char *host, int *port)
{
	cui panel = host_port_panel;
	cui etxt = host_port_etxt;
	cui num = host_port_num;

	if(host_port_panel == NULL){
		int w = strlen("(OK)") + 1 + strlen("(Cancel)");
		cui view, ok, cancel;

		panel = cui_panel_new(NULL, 0, 0, 0, 0);
		cui_hide(panel);
		cui_wh_set(panel, w+2, 6);

		view = cui_base_new(panel, 1, 1, w, 4);
		etxt = cui_etext_new(view, 0, 0, view->w, "localhost");
		num = cui_num_new(view, 0, 1, view->w, 12345, 0, 65535, 0);
		ok = cui_button_new(view, 0, 3, "OK");
		cancel = cui_button_new(view, cui_x2(ok)+1, ok->y, "Cancel");

		cui_bind(ok, CUI_EVT_BUTTON, ok_cancel_hdr, &host_port_result);
		cui_bind(cancel, CUI_EVT_BUTTON, ok_cancel_hdr, &host_port_result);

		host_port_panel = panel;
		host_port_etxt = etxt;
		host_port_num = num;
	}
	panel->parent = parent;
	cui_base_child_add(parent, panel);
	cui_xy_set(panel, x, y);
	cui_show(panel);

	cui_main(panel, etxt);
	cui_hide(panel);
	cui_draw(parent);
	if(host_port_result){
		strcpy(host, cui_etext_str_get(etxt));
		*port = cui_num_get(num);
	}
	cui_del(panel);
	return host_port_result;
}

int
cui_confirm_dialog(cui parent, char *s)
{
	int n = strlen(s);
	int bw = strlen("(OK)") + 1 + strlen("(Cancel)");
	int w = n > bw ? n : bw;
	int x = (parent->w - (w+4)) / 2;
	int y = (parent->h - 5) / 2;
	cui panel = cui_panel_new(parent, x, y, w+4, 5);
	cui view = cui_base_new(panel, 2, 1, w, 3);
	cui ok, cancel;
	int result;

	cui_label_new(view, 0, 0, s);
	x = (w - bw) / 2;
	y = 2;
	ok = cui_button_new(view, x, y, "OK");
	cancel = cui_button_new(view, cui_x2(ok)+1, y, "Cancel");
	cui_bind(ok, CUI_EVT_BUTTON, ok_cancel_hdr, &result);
	cui_bind(cancel, CUI_EVT_BUTTON, ok_cancel_hdr, &result);

	cui_main(panel, cancel);
	cui_hide(panel);
	cui_draw(parent);
	cui_del_free(panel);
	return result;
}

/* EOF */
