#include "handler.h"
#include <stdio.h>
#include <stdlib.h>

typedef struct cui_handler_data{
	cui_handler hdr;
	int evt;
	void *prm;
} *cui_handler_data;

void
cui_bind(cui obj, int evt, cui_handler hdr, void *prm)
{
	cui_handler_data p = cui_list_add(&obj->handler_list, sizeof(struct cui_handler_data));
	p->hdr = hdr;
	p->evt = evt;
	p->prm = prm;
}

void
cui_unbind(cui obj, int evt, cui_handler hdr)
{
	cui_list lp = obj->handler_list, next;
	cui_handler_data p;
	for(; lp; lp=next){
		next = lp->next;
		p = (cui_handler_data)lp->data;
		if(p->evt & evt && p->hdr == hdr){
			p->evt &= ~evt;
			if(p->evt == 0) cui_list_del(&obj->handler_list, p);
		}
	}
}

static int
cui_handler_call_chain(cui obj, cui_list lp, int evt, int val)
{
	cui_list next;
	cui_handler_data p;
	if(lp == NULL) return FALSE;
	next = lp->next;
	p = (cui_handler_data)lp->data;
	return (evt & p->evt) && (*p->hdr)(obj, evt, val, p->prm) ? TRUE : 
		cui_handler_call_chain(obj, next, evt, val);
}

int
cui_handler_call(cui obj, int evt, int val)
{
	return cui_handler_call_chain(obj, obj->handler_list, evt, val);
}

/* EOF */
