#ifndef __MENU_H__
#define __MENU_H__

#include "button.h"
#include "lblfix.h"

typedef struct cui_menu_btn{
	struct cui_button button;
} *cui_menu_btn;

typedef struct cui_menu_item{
	struct cui_base base;
	cui lbf, lb_end;
} *cui_menu_item;

typedef struct cui_menu_popup{
	struct cui_menu_item item;
	cui menu;
	int val, *vp;
	int call_btn_hdr_flag; /* ! */
} *cui_menu_popup;

typedef struct cui_menu_int{
	struct cui_menu_popup popup;
	void *alloc;
	char **lst;
	int v, min_v, max_v, *vp;
} *cui_menu_int;

typedef struct cui_menu_pulldown{
	struct cui_base base;
	cui btn, menu;
	int v, *vp;
} *cui_menu_pulldown;

cui cui_menu_btn_new(cui parent, int x, int y, char *s);
void cui_menu_btn_init(cui obj, cui parent, int x, int y, char *s);
int cui_menu_btn_hdr(cui obj, int evt, int val, void *prm);
char *cui_menu_btn_str_get(cui obj);
void cui_menu_btn_str_set(cui obj, char *s);

cui cui_menu_item_new(cui parent, int x, int y, char *s);
void cui_menu_item_init(cui obj, cui parent, int x, int y, char *s);
int cui_menu_item_hdr(cui obj, int evt, int val, void *prm);
char *cui_menu_item_str_get(cui obj);
void cui_menu_item_str_set(cui obj, char *s);

cui cui_menu_new(cui parent, int x, int y, char **lst);
cui cui_menu_str_to_item(cui menu, char *s);
int cui_menu_item_num(cui obj);
cui cui_menu_item_get(cui obj, int i);

cui cui_menu_popup_new(cui parent, int x, int y, int w, char **lst, int val);
void cui_menu_popup_init(cui obj, cui parent, int x, int y, int w, char **lst, int val);
int cui_menu_popup_hdr(cui obj, int evt, int val, void *prm);
char *cui_menu_popup_str_get(cui obj);
int cui_menu_popup_get(cui obj);
void cui_menu_popup_set(cui obj, int idx);
void cui_menu_popup_del_free(cui obj);
void cui_menu_popup_vp_set(cui obj, int *vp);

cui cui_menu_int_new(cui parent, int x, int y, int w, int init_v, int min_v, int max_v);
void cui_menu_int_init(cui obj, cui parent, int x, int y, int w, int init_v, int min_v, int max_v);
int cui_menu_int_hdr(cui obj, int evt, int val, void *prm);
void cui_menu_int_lst_free(cui obj);
int cui_menu_int_get(cui obj);
void cui_menu_int_set(cui obj, int v);
void cui_menu_int_vp_set(cui obj, int *vp);
void cui_menu_int_min_max_set(cui obj, int min_v, int max_v);
void cui_menu_int_del_free(cui obj);

cui cui_menu_pulldown_new(cui parent, int x, int y, char *s, char **lst);
void cui_menu_pulldown_init(cui obj, cui parent, int x, int y, char *s, char **lst);
int cui_menu_pulldown_hdr(cui obj, int evt, int val, void *prm);
int cui_menu_pulldown_get(cui obj);
void cui_menu_pulldown_vp_set(cui obj, int *vp);
cui cui_menu_pulldown_menu_get(cui obj);
char *cui_menu_pulldown_str_get(cui obj);
void cui_menu_pulldown_del_free(cui obj);

#endif
