#include "readable.h"
#include "select.h"
#include "handler.h"
#include <stdio.h>

typedef struct cui_readable{
	cui obj;
	int fd;
} *cui_readable;

static cui_list readable_list = NULL;

void
cui_readable_add(cui obj, int fd)
{
	cui_readable p = cui_list_add(&readable_list, sizeof(struct cui_readable));
	p->obj = obj;
	p->fd = fd;
	cui_select_add(fd);
}

void
cui_readable_del(cui obj, int fd)
{
	cui_list lp = readable_list;
	cui_readable p;
	for(; lp; lp=lp->next){
		p = (cui_readable)lp->data;
		if(p->obj == obj && p->fd == fd) break;
	}
	if(lp == NULL) return;
	cui_list_del(&readable_list, p);
	cui_select_del(fd);
}

void
cui_readable_add_bind(cui obj, int fd, cui_handler hdr, void *prm)
{
	cui_bind(obj, CUI_EVT_READABLE, hdr, prm);
	cui_readable_add(obj, fd);
}

void
cui_readable_work(void)
{
	cui_list lp = readable_list, next;
	cui_readable p;
	for(; lp; lp=next){
		next = lp->next;
		p = (cui_readable)lp->data;
		if(!cui_select_chk(p->fd)) continue;
		cui_handler_call(p->obj, CUI_EVT_READABLE, p->fd);
	}
}

/* EOF */
