#ifndef __RECT_H__
#define __RECT_H__

typedef struct cui_rect{
	int x, y, w, h;
} *cui_rect;

typedef struct cui_rects *cui_rects;

struct cui_rects{
	struct cui_rect r;
	cui_rects next;
} ;

void cui_rect_init(cui_rect r, int x, int y, int w, int h);
void cui_rect_wh_to_x2y2(cui_rect r);
void cui_rect_x2y2_to_wh(cui_rect r);
int cui_rect_and(cui_rect a, cui_rect b, cui_rect r);
int cui_rect_chk_empty(cui_rect r);
int cui_rect_x2(cui_rect r);
int cui_rect_y2(cui_rect r);
void cui_rect_x1_set(cui_rect r, int x1);
void cui_rect_y1_set(cui_rect r, int y1);
void cui_rect_x2_set(cui_rect r, int x2);
void cui_rect_y2_set(cui_rect r, int y2);
int cui_rect_eq(cui_rect a, cui_rect b);

cui_rects cui_rects_new(int x, int y, int w, int h, cui_rects next);
cui_rects cui_rects_new_rect(cui_rect r, cui_rects next);
void cui_rects_init(cui_rects rs, int x, int y, int w, int h, cui_rects next);
void cui_rects_del_from(cui_rects rs, cui_rects *from);
void cui_rects_free(cui_rects rs);
cui_rects cui_rect_or(cui_rect a, cui_rect b);

#endif
