#include "rszbox.h"
#include "handler.h"
#include "key.h"
#include <stdio.h>

cui
cui_rszbox_new(cui parent)
{
	cui obj = cui_alloc(sizeof(struct cui_rszbox));
	cui_rszbox_init(obj, parent);
	return obj;
}

void
cui_rszbox_init(cui obj, cui parent)
{
	cui_fillbtn_init(obj, parent, parent->w-1, parent->h-1, 1, 1, "+");
	cui_bind(obj, CUI_EVT_KEY, cui_rszbox_hdr, NULL);
}

void
cui_rszbox_update(cui obj)
{
	cui_wh_set(obj->parent, obj->x+1, obj->y+1);
}

int
cui_rszbox_hdr(cui obj, int evt, int val, void *prm)
{
	cui_rszbox p = (cui_rszbox)obj;

	/* evt == CUI_EVT_KEY */

	if(!cui_fillbtn_val_get(obj)){
		if(val != CUI_KEY_ENTER) return FALSE;
		cui_fillbtn_val_set(obj, TRUE);
		p->bak_x = obj->x;
		p->bak_y = obj->y;
		return TRUE;
	}else{
		switch(val){
		case CUI_KEY_ESC:
			if(obj->x != p->bak_x || obj->y != p->bak_y){
				obj->x = p->bak_x;
				obj->y = p->bak_y;
				cui_rszbox_update(obj);
			}
		case CUI_KEY_ENTER:
			cui_fillbtn_val_set(obj, FALSE);
			return TRUE;
		case CUI_KEY_UP:
			if(obj->y > 0){
				obj->y--;
				cui_rszbox_update(obj);
			}
			return TRUE;
		case CUI_KEY_DOWN:
			obj->y++;
			cui_rszbox_update(obj);
			return TRUE;
		case CUI_KEY_LEFT:
			if(obj->x > 0){
				obj->x--;
				cui_rszbox_update(obj);
			}
			return TRUE;
		case CUI_KEY_RIGHT:
			obj->x++;
			cui_rszbox_update(obj);
			return TRUE;
		}
	}	
	return FALSE;
}

/* EOF */
