#include "select.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>

static fd_set sel_rfs, res_rfs;

void
cui_select_init(void)
{
	FD_ZERO(&sel_rfs);
}

void
cui_select_add(int fd)
{
	FD_SET(fd, &sel_rfs);
}

void
cui_select_del(int fd)
{
	FD_CLR(fd, &sel_rfs);
}

int
cui_select(int usec)
{
	int nfds = 0, fd;
	struct timeval tm;

	res_rfs = sel_rfs;
	for(fd=0; fd<FD_SETSIZE; fd++) if(FD_ISSET(fd, &res_rfs) && fd > nfds) nfds = fd;
	tm.tv_sec = 0;
	tm.tv_usec = usec;
	return select(nfds+1, &res_rfs, NULL, NULL, &tm);
}

int
cui_select_chk(int fd)
{
	return FD_ISSET(fd, &res_rfs);
}

int
cui_select_readable_chk(int fd, int usec)
{
	fd_set rfs;
	struct timeval tm;

	FD_ZERO(&rfs);
	FD_SET(fd, &rfs);
	tm.tv_sec = 0;
	tm.tv_usec = usec;
	return select(fd+1, &rfs, NULL, NULL, &tm) > 0;
}

/* EOF */
