#include "sock.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

int
cui_conn_host_port(char *host, int port)
{
	struct sockaddr_in addr;
	struct hostent *hp;
	int fd;

	if((hp = gethostbyname(host)) == NULL) return -1;
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
	memcpy(&addr.sin_addr, hp->h_addr, hp->h_length);
	if((fd = socket(AF_INET, SOCK_STREAM, 0)) == -1) return -1;
	if(connect(fd, (struct sockaddr *)&addr, sizeof(addr)) < 0){
		close(fd);
		return -1;
	}
	return fd;
}

int
cui_conn(char *s)
{
	int i, port;
	char name[1024];

	for(i=0; s[i]; i++) if(s[i] == ':') break;
	if(i > 0 && s[i]){
		memcpy(name, s, i);
		name[i] = '\0';
	}else strcpy(name, "localhost");
	i = s[i] ? i + 1 : 0;
	port = strtol(s+i, NULL, 0);

	return cui_conn_host_port(name, port);
}

int
cui_srv_port(int port)
{
	int sfd;
	struct sockaddr_in saddr;

	if((sfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) return -1;
	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = htonl(INADDR_ANY);
	saddr.sin_port = htons(port);
	if(bind(sfd, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
		close(sfd);
		return -1;
	}
	if(listen(sfd, 5) == -1){
		close(sfd);
		return -1;
	}
	return sfd;
}

int
cui_srv_accept(int sfd)
{
	struct sockaddr_in caddr;
	socklen_t clen = sizeof(caddr);
	int cfd;

	memset(&caddr, 0, clen);
	if((cfd = accept(sfd, (struct sockaddr *)&caddr, &clen)) == -1) return -1;
	return cfd;
}

/* EOF */
