#ifndef __TERM_H__
#define __TERM_H__

#include "cui.h"

typedef struct cui_term{
	struct cui_base base;
	char *buf, *lbuf;
	int cx, cy, bfy;
	int cursor_onoff;
	int attr;

	int update_all;

	char esc_buf[16];
	int esc_buf_n;
	int ow, oh;
} *cui_term;

typedef struct cui_termin{
	struct cui_base base;
	cui term;
	cui fill[4];
	int sock;
	int in_key_mode;
} *cui_termin;

typedef struct cui_terminal{
	struct cui_termin termin;
	int sock, pid;
} *cui_terminal;

cui cui_term_new(cui parent, int x, int y, int w, int h);
void cui_term_init(cui obj, cui parent, int x, int y, int w, int h);
int cui_term_hdr(cui obj, int evt, int val, void *prm);
void cui_term_buf_alloc(cui obj);
void cui_term_buf_free(cui obj);

void cui_term_putc(cui obj, char c);
void cui_term_putc_buf(cui obj, char c);
void cui_term_putc_buf_inner(cui obj, char c);

void cui_term_puts(cui obj, char *s);
void cui_term_puts_buf(cui obj, char *s);
void cui_term_puts_buf_inner(cui obj, char *s);

void cui_term_cr(cui obj);
void cui_term_lf(cui obj);
void cui_term_nl(cui obj);
char *cui_term_buf(cui obj, int cx, int cy);
void cui_term_move(cui obj, int cx, int cy);
void cui_term_update(cui obj);

/**/

cui cui_termin_new(cui parent, int x, int y, int w, int h, int sock);
void cui_termin_init(cui obj, cui parent, int x, int y, int w, int h, int sock);
int cui_termin_hdr(cui obj, int evt, int val, void *prm);
void cui_termin_kill(cui obj);
void cui_termin_del_free(cui obj);

/**/

cui cui_terminal_new(cui parent, int x, int y, int w, int h);
void cui_terminal_init(cui obj, cui parent, int x, int y, int w, int h);
int cui_terminal_hdr(cui obj, int evt, int val, void *prm);
void cui_terminal_kill(cui obj);
void cui_terminal_del_free(cui obj);

#endif
