#include "timer.h"
#include "handler.h"
#include "list.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

static cui_list timer_list = NULL;

typedef struct cui_timer{
	cui obj;
	int msec;
	int once;
	int targ_msec;
} *cui_timer;

int
cui_timer_now_msec(void)
{
	struct timeval tm;
	gettimeofday(&tm, NULL);
	return tm.tv_sec * 1000 + tm.tv_usec / 1000;
}

static void
cui_timer_init(cui_timer p, cui obj, int msec, int once)
{
	p->obj = obj;
	p->msec = msec;
	p->once = once;
	p->targ_msec = cui_timer_now_msec() + msec;
}

void
cui_timer_set(cui obj, int msec, int once)
{
	cui_timer p;
	cui_list lp = timer_list;
	for(; lp; lp=lp->next){
		p = (cui_timer)lp->data;
		if(p->obj == obj) break;
	}
	if(lp == NULL){
		p = cui_list_add(&timer_list, sizeof(struct cui_timer));
		cui_timer_init(p, obj, msec, once);
		return;
	}
	if(msec >= 0){
		cui_timer_init(p, obj, msec, once);
		return;
	}
	cui_list_del(&timer_list, p);
}

void
cui_timer_work(void)
{
	cui_list lp = timer_list, next;
	cui_timer p;
	int msec;
	for(; lp; lp=next){
		next = lp->next;
		p = (cui_timer)lp->data;
		msec = cui_timer_now_msec();
		if(msec < p->targ_msec) continue;
		cui_handler_call(p->obj, CUI_EVT_TIMER, msec);
		if(p->once) cui_list_del(&timer_list, p);
		else p->targ_msec += p->msec;
	}
}

void
cui_timer_set_bind(cui obj, int msec, int once, cui_handler hdr, void *prm)
{
	cui_bind(obj, CUI_EVT_TIMER, hdr, prm);
	cui_timer_set(obj, msec, once);
}

/* EOF */
